// AiLongDlg.h : wb_[ t@C
//

#pragma once
#include "afxwin.h"
#include "Windows.h"

/////////////////////////////////////////////////////////////////////////////
// CAiLongDlg _CAO

class CAiLongDlg : public CDialog
{
// \z
public:
	CAiLongDlg(CWnd* pParent = NULL);	// W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(CAiLongDlg)
	enum { IDD = IDD_AILONG_DIALOG };
	CStatic	m_Total;
	CStatic	m_Event;
	CStatic	m_Status;
	CStatic	m_Count;
	CStatic	m_ErrorString;
	CComboBox	m_AiRange;
	CEdit	m_Device;
	//ǉ
	CComboBox m_FFT_WND;
	CEdit m_FFT_Num;
	CStatic m_PICT_QL;
	CStatic m_PICT_SP;
	CComboBox m_Freq_List;
	CComboBox m_ch;
	CComboBox m_ch_disp;
	CEdit m_EDIT_SF;
	CEdit m_EDIT_EF;

	CEdit m_STA;
	CEdit m_EDIT_X1;
	CEdit m_EDIT_X2;
	CEdit m_EDIT_SFM;
	CStatic m_IDC_PICT_LM;

	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAiLongDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	virtual LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CAiLongDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonInit();
	afx_msg void OnSelchangeComboRange();
	afx_msg void OnButtonEnd();
	afx_msg void OnButtonSet();
	afx_msg void OnButtonStart();
	afx_msg void OnButtonStatus();
	afx_msg void OnButtonStop();
	afx_msg void OnTimer(UINT nIDEvent);	// 2016-08-03
	afx_msg void OnCancel();				// 2016-08-03
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

	//XyNgf[^ۑꍇ͒`
	//2ch̓[hɂ͖ɂ(CPUp[Ɉˑj
	#define d_SPC

	// SW version (since Ver.2.5)
	#define	sw_ver		2
	#define	sw_subver	6

	//֐̖߂l
	long	Ret, Ret2;
	//ID
	short	Id;
	//gp`l
	short	AiChannels;
	//G[R[h
	char	ErrorString[256];
	//ϊf[^i[pz
	#define	DATA_SMP	200000					//1bɎ擾f[^_iTvOgj
	#define n_ch_max	2
	int		n_ch;								//number of channel
	float	AiData[DATA_SMP*n_ch_max];			//200ks x ch
	//Cxg
	long	AiEventCount;
	//擾TvO
	long	AiTotalSamplingTimes;
	//񏑎쐬p
	CString	TextString;
	CString	TextTemp;

	//FFT
	void FFT_excute(long n_fft, float *v_fft1, float *v_fft2);
	#define Pi 3.1415926						//~
	#define n_fft_max 40000						//FFT_(ől)
	long	n_fft;								//FFT_([U)
	
	//|Cggf[^pin_fft/DATA_SMP (b)ԕ\ƂȂj
	float v_fft1[n_fft_max],v_fft2[n_fft_max];	//FFTpo͕ϐ
	float w_fft[n_fft_max];						//Window֐
	float f_fft[n_fft_max/2+1];					//gz

	//σXyNgf[^p
    #define n_save_f 1							//XyNgf[^̐ϕш(|Cg)
    #define n_save_t 30							//XyNgf[^̐ϕ(b)
	#define n_spc_ch  ( n_fft_max / n_save_f / 2 + 1 ) 
	int n_save_count;							//ϕJEgϐ
	float ave_pow[n_spc_ch * n_ch_max];			//FFTϏo(U)
	float ave_sin[n_spc_ch * n_ch_max];			//FFTϏo(ʑsin)
	float ave_cos[n_spc_ch * n_ch_max];			//FFTϏo(ʑcos)
	float ave_frq[n_spc_ch];					//σf[^pgz
	short pow_save[n_spc_ch];					//UpۑpziϊWF100j
	short pha_save[n_spc_ch];					//ʑpۑpziϊWF1000j
	float pow_ref;								// conversion from dBc to dBVpp(out)

	// Device and Station name
	void Read_Dev(void);

	//ϑgݒ
	void Read_Fq(float* fq, int* ifw);
	#define n_fq_max 20							//ۑg_(őlFRg[̐Ō܂)
	int	  n_fq; 								//ۑg_
	float fq[n_fq_max];							//ۑg
	long ifq[n_fq_max];							//ۑgCfbNX
	int  ifw[n_fq_max];							//gш敝
	float sf,ef;								//sfericsJnEIg
	long isf, ief;								//sfericsJnEIgCfbNX
	short fq_pw[n_fq_max],fq_ph[n_fq_max];		//ۑf[^iUEʑj
	float ave_pow_p[n_fq_max];					//|CggATu(U)
	float ave_sin_p[n_fq_max];					//|CggATu(ʑsin)
	float ave_cos_p[n_fq_max];					//|CggATu(ʑcos)

	//p
	CString NowTime;
	CTime CurTime;

	//`p
	void Draw_SP(float *x, float *ya, float *yp, float *fq, int i_col);
	void Draw_QL(float phase, int i_col);
	void Draw_LM(float sferics);

	//p
	void Prog_Init();
	void Prog_Range();
	void Prog_Set();
	void Prog_Start();
	void Prog_Stop();
	void Prog_End();
	void Prog_Error(CString Str_error, CString Str_time);
	void Prog_Save_Error(CString Str_error, CString Str_time);

	//f[^ۑpt@C
	CString sFile1,sFile2;
	CString sDate, sSta, sCh;
	CFileStatus FileStat; 

	//AD error
	#define n_error_max 10								//Number of error for program reset
	unsigned int n_error;

	//Rg[zp
	CEdit m_Edit_fq[n_fq_max];
	CEdit m_Edit_pw[n_fq_max];
	CEdit m_Edit_ph[n_fq_max];

	//WDTp
	#define n_wdt_max 10
	unsigned int m_n_wdt;
	unsigned int n_wdt;
	unsigned int n_wdt_hist;
	CEdit        m_wdt;
};
